<?php

// ------------------------------------------------------------------------------------------------------------------------------
// Fastnacht, Fasnacht, Fasnet, Fassenacht oder einfach Karneval - wie auch immer in Eurer Region genannt.
// Ihr müsst nur die jeweiligen (siehe Dokumentation) Passagen anpassen.
// Dieser Fastnachts-Termin-Kalender wurde ursprünglich für Wiesbaden (Hessen) erstellt.
// sgs-visual.de 2024
//
// Ich übernehme für dieses Script keine Garantie für Funktionalität und keine Haftung bei evtl. Schäden,
// die durch die Nutzung dieses Scriptes entstehen könnten.
// -------------------------------------------------------------------------------------------------------------------------------

?>

<html>
<body>

<style>

/* --- Hier im CSS können die Werte verändert werden --- */

/* --- CSS Header-Box --- */

      .GrafikBox {
       width: 280px;
       background-color: #2E65D9;
       font-family: Arial;
       font-size: 16px;
       color: #FFFFFF;
        border: 2px solid #000000;
        border-radius: 15px 15px 15px 15px;
        margin:  5px;
        padding: 5px;
        box-shadow: #AFAFAF 5px 6px 20px 0px;
       }

       tt {
       font-size: 12px;
       color: #FFFFFF;
       }

/* --- CSS Box für Termine im aktuellen Jahr --- */

       .ErsteBox {
       width: 280px;
       font-family: Arial;
       font-size: 14px;
       color: #000000;
       background-color: #FFE281;
       border:  2px solid #000000;
       border-radius : 15px 15px 0px 0px;
       margin:  5px;
       padding: 5px;
       box-shadow: #AFAFAF 5px 6px 20px 0px;
       }

/* --- CSS Box für Termine im folgendem Jahr --- */

       .ZweiteBox {
       width: 280px;
       font-family: Arial;
       font-size: 14px;
       color: #000000;
        background-color: #FFFFFF;
        border: 2px solid #000000;
        border-radius: 0px 0px 15px 15px;
        margin:  5px;
        padding: 5px;
        box-shadow: #AFAFAF 5px 6px 20px 0px;
        }

/* --- CSS Ende --- */

  </style>

<center>

<! -- Header-Box # Hier werden auch Grafiken geladen. Bitte den Titel hier anpassen. -->
<! -- Werden die Grafiken in einem anderen Ordner auf dem Server abgelegt, dann die URL zur Grafik anpassen! -->

<div class="GrafikBox">
<center><img src="fastnachtstermine_narr.png">&nbsp;<b>Fastnacht-Termine in</b>&nbsp;<img src="fastnachtstermine_wappen_wbn.png"><br><b>Wiesbaden</b><br>

<! -- Hier kann der zusätzliche Text unter dem Titel bearbeitet werden.. -->

<tt>Die Kampagne beginnt jedes Jahr am 11.November um 11:11 Uhr.</tt><br></center>

<! -- Ende der Header-Box -->

</div>

<! -- Erste Box mit Terminen aus dem aktuellem Jahr -->

<div class="ErsteBox">

</body>
</html>


<?php

// --- Jetzt wird das  aktuelle und das folgende Jahr ermittelt ---

$aktuellesJahr = date('Y');
$naechstesJahr = $aktuellesJahr +1;

// --- Inhalt der ersten Box mit dem aktuellen Jahr ---

echo "<b>Termine&nbsp;$aktuellesJahr</b><br><hr><br>";

// -------------------------------------------------------------------------------------------------------
// --- In diesem Abschnitt KEINE ÄNDERUNGEN Durchführen, sonst funktioniert das Script nicht mehr !!! ---
// -------------------------------------------------------------------------------------------------------

// --- Info: hier wird der Termin von OSTERN im aktuellen Jahr ermittelt ---

function eastern($year){
    
    $X = $year;
    $K = floor ( $X / 100 ); 
    $M = 15 + floor ( ( ( 3 * $K ) + 3 ) / 4 ) - 
            floor ( ( ( 8 * $K ) + 13 ) / 25 ); 
    $S = 2 - floor ( ( ( 3 * $K ) + 3 ) / 4 ); 
    $A = $X % 19; 
    $D = ( 19 * $A + $M ) % 30; 
    $R = floor ( $D / 29 ) + ( floor ( $D / 28 ) -
            floor ( $D / 29 ) ) * floor ( $A / 11 ); 

    $OG = 21 + $D - $R;
    $SZ = 7 - ( ( $X + floor ( $X / 4 ) + $S ) % 7 );
    $OE = 7 - ( ( $OG - $SZ ) %7 ); 
    $OS = $OG + $OE; 

    return $OS;
    
}

?>

 <?php

// --------------------------------------------------------------------------
// Hier wird der erste Termin erstellt. z.B. vom Ostersonntag zurückgerechnet sind es 46 Tage um auf Aschermittwoch zu gelangen.
// --------------------------------------------------------------------------

for ( $x = $aktuellesJahr; $x <= $aktuellesJahr; $x++ ) {
    
    $ostern = eastern ($x);

// --- in dieser Zeile wird für den Termin für den Samsta vor Aschermittwoch   $ostern -50  geschrieben ---

    $kinderumzug = $ostern - 50;
    $dateFormat = date ( 'd.m.Y', mktime ( 0, 0, 0, 3, $kinderumzug, $x ) );

// --- in dieser Zeile steht der Text, der für den Termin ausgegeben wird. ---

    echo 'Der Kinder- Umzug ist am:&nbsp;' . $dateFormat . "\n";
    
}

// --- Ende des ersten Termin ---

?>

<br>

 <?php

// --- Hier folgt der zweite Termin ---

for ( $x = $aktuellesJahr; $x <= $aktuellesJahr; $x++ ) {
    
    $ostern = eastern ($x);
    $sonntagsumzug = $ostern - 49;
    $dateFormat = date ( 'd.m.Y', mktime ( 0, 0, 0, 3, $sonntagsumzug, $x ) );
    echo 'Der große Umzug ist am:&nbsp;&nbsp;&nbsp;&nbsp;' . $dateFormat . "\n";
    
}

// --- Ende zweiter Termin ---

?>

<br><br>

 <?php

// --- Hier folgen die Termine Rosenmontag bis Aschermittwoch ---

for ( $x = $aktuellesJahr; $x <= $aktuellesJahr; $x++ ) {
    
    $ostern = eastern ($x);
    $rosenmontag = $ostern - 48;
    $dateFormat = date ( 'd.m.Y', mktime ( 0, 0, 0, 3, $rosenmontag, $x ) );
    echo 'Rosenmontag ist am:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $dateFormat . "\n";
    
}

?>  

<br>

<?php

for ( $x = $aktuellesJahr; $x <= $aktuellesJahr; $x++ ) {
    
    $ostern = eastern ($x);
    $faschingsdienstag = $ostern - 47;
    $dateFormat = date ( 'd.m.Y', mktime ( 0, 0, 0, 3, $faschingsdienstag, $x ) );
    echo 'Faschingsdienstag ist am:&nbsp;&nbsp;&nbsp;&nbsp;' . $dateFormat . "\n";
    
}

?> 

<br>

<?php

for ( $x = $aktuellesJahr; $x <= $aktuellesJahr; $x++ ) {
    
    $ostern = eastern ($x);
    $aschermittwoch = $ostern - 46;
    $dateFormat = date ( 'd.m.Y', mktime ( 0, 0, 0, 3, $aschermittwoch, $x ) );
    echo 'Aschermittwoch ist am:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $dateFormat . "\n";
    
}

?> 

</div>
  <div class="ZweiteBox">

 <?php

// --------------------------------------
// -- Termine für das nächste Jahr
// --------------------------------------

echo "<b>Termine&nbsp;$naechstesJahr</b><br><hr><br>";

?>

 <?php

for ( $x = $naechstesJahr; $x <= $naechstesJahr; $x++ ) {
    
    $ostern = eastern ($x);
    $kinderumzug2 = $ostern - 50;
    $dateFormat = date ( 'd.m.Y', mktime ( 0, 0, 0, 3, $kinderumzug2, $x ) );
    echo 'Der Kinder- Umzug ist am:&nbsp;' . $dateFormat . "\n";
    
}

?>

<br>

<?php

for ( $x = $naechstesJahr; $x <= $naechstesJahr; $x++ ) {
    
    $ostern = eastern ($x);
    $sonntagsumzug2 = $ostern - 49;
    $dateFormat = date ( 'd.m.Y', mktime ( 0, 0, 0, 3, $sonntagsumzug2, $x ) );
    echo 'Der große Umzug ist am:&nbsp;&nbsp;&nbsp;&nbsp;' . $dateFormat . "\n";
    
}

?>

<br><br>

 <?php

for ( $x = $naechstesJahr; $x <= $naechstesJahr; $x++ ) {
    
    $ostern = eastern ($x);
    $rosenmontag2 = $ostern - 48;
    $dateFormat = date ( 'd.m.Y', mktime ( 0, 0, 0, 3, $rosenmontag2, $x ) );
    echo 'Rosenmontag ist am:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $dateFormat . "\n";
    
}

?>  

<br>

<?php

for ( $x = $naechstesJahr; $x <= $naechstesJahr; $x++ ) {
    
    $ostern = eastern ($x);
    $faschingsdienstag2 = $ostern - 47;
    $dateFormat = date ( 'd.m.Y', mktime ( 0, 0, 0, 3, $faschingsdienstag2, $x ) );
    echo 'Faschingsdienstag ist am:&nbsp;&nbsp;&nbsp;&nbsp;' . $dateFormat . "\n";
    
}

?> 

<br>

<?php

for ( $x = $naechstesJahr; $x <= $naechstesJahr; $x++ ) {
    
    $ostern = eastern ($x);
    $aschermittwoch2 = $ostern - 46;
    $dateFormat = date ( 'd.m.Y', mktime ( 0, 0, 0, 3, $aschermittwoch2, $x ) );
    echo 'Aschermittwoch ist am:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $dateFormat . "\n";
    
}

?> 

<html><body>
</div>
</center>
</body></html>